library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity onehot_binary_tb is
end;

architecture tb of onehot_binary_tb is

  signal A : std_logic_vector(0 to 7);
  signal F : std_logic_vector(2 downto 0);

begin

  uut : entity work.onehot_binary
    generic map ( N => 8,
                  M => 3 )
    port map (    onehot_in => A,
                 binary_out => F );

  process
  begin
    for I in A'RANGE loop
      A <= (others => '0');
      A(I) <= '1';
      wait for 10 ns;
      assert I = to_integer(unsigned(F))
        report "Nope: Wanted " & INTEGER'IMAGE(I)
               & ", got "      & INTEGER'IMAGE(to_integer(unsigned(F)))
        severity ERROR;
    end loop;
    wait;
  end process;

end;
